; BorgIRC - Sound system file #1/2
; --------------------------------------------------------

alias on fx beep
alias off fx button

dialog fxctrl {
  title "BorgIRC Multimedia system control"
  size -1 -1 245 155
  icon $bico
  option dbu
  tab "General",1, 1 1 243 135
  tab "File types",2
  ;  tab "Sound server",3
  tab "Jukebox",4 
  ;  tab "Sound effects",5 
  tab "Misc. options",6

  check "Enable BorgIRC sound system",8,5 20 85 7,tab1
  check "Enable sound server",9,5 34 85 7,tab1
  check "Enable sound grabber",10,5 41 85 7,tab1
  check "Enable sound effects",11,5 48 85 7,tab1

  ;  text "Sound system complexity",12,5 60 100 7,tab1 disable
  ;  radio "Simple mode",13,5 72 50 7,tab1 disable
  ;  radio "Advanced mode",14,5 79 50 7,tab1 disable

  box "Supported file types",15,2 18 239 117,left tab2
  list 16,5 27 47 107,left tab2 sort
  button "Add",17,53 27 30 10,tab2
  button "Remove",18,53 37 30 10,tab2 disable

  box "",19,85 18 156 117, tab2

  check "Enable support for this file type",20,88 30 90 6,right tab2 hide
  check "Enable remote play",21,88 37 90 6,right tab2 hide
  check "Enable auto play on receive",22,88 44 90 7,right tab2

  radio "Use mIRC internal player",23,88 58 90 7,right tab2 disable hide
  radio "Use Windows registered player",24,88 65 90 7,right tab2 disable hide
  radio "Use custom player",25,88 72 90 7,right tab2 hide

  button "&Play settings",26,115 112 50 12,tab2
  button "&Folder settings",27,165 112 50 12,tab2

  edit "",28,88 81 147 10,autohs tab2 hide

  button "Browse..",29,165 92 35 10,tab2 hide
  button "Auto-detect",30,200 92 35 10,tab2 hide

  check "Grab this file type",31,180 30 55 7,tab2
  check "Serve this file type",32,180 37 55 7,tab2
  text "Please select a file type",33,140 70 100 7,tab2

  check "Use a default Jukebox startup file type/folder",34,5 20 120 7,tab4

  text "File type:",35,20 30 23 7,tab4
  combo 36,45 28 25 75,drop tab4
  text "Folder:",37,20 41 19 7,tab4
  combo 38,45 39 80 50,drop,tab4

  check "Display MP3 header info in jukebox",39,5 71 100 7,tab4

  text "On doubleclick on file:",40,5 55 55 7,tab4
  combo 41,60 53 62 60,tab4 drop

  check "Auto-minimize jukebox when playing",42,5 78 95 7,tab4

  button " X ",80,5 20 10 10,tab6
  text "Set identical external player for all sound types except for WAV,MID",81,20 22 180 7,tab6
  button " X ",82,5 30 10 10,tab6
  text "Auto-detect identical external player for all sound types except for WAV,MID",83,20 32 180 7,tab6
  button " X ",84,5 40 10 10,tab6
  text "Reset external player for all sounds types except for WAV,MID",85,20 42 180 7,tab6
  button "&Playlist generator",86,5 58 60 12,tab6

  check "Enable remote play triggering messages",87,5 62 120 7,tab1


  icon 496, 106 134 230 25 25,system\gfx\borgirc.png,1
  button "&Help",498,104 140 45 13,disable
  button "&Reset", 497, 54 140 45 13,ok disable
  button "&OK", 499, 4 140 45 13,ok
}

on *:dialog:fxctrl:init:0: { 
  get_fxcfg g | var %tmp = 0 | while (%tmp < $numtok($fx_ext,35)) { inc %tmp | did -a fxctrl 16 $gettok($fx_ext,%tmp,35) }
  if ($fx_sndsys == on) { did -c fxctrl 8 } | else { md -b fxctrl 9 12 }
  if ($fx_serv == on) { did -c fxctrl 9 } | if ($fx_grab == on) { did -c fxctrl 10 } | if ($fx_sfx == on) { did -c fxctrl 11 }
  if ($get_fxcfg(o,general,rtrig)) { did -c fxctrl 87 }
  md2 -a fxctrl 41 [No action],Public play,Private play,Random public play,Random private play
}

on *:dialog:fxctrl:sclick:*:{ var %tmp = $did(fxctrl,16,$did(fxctrl,16).sel).text | goto $did 
  :0 | :1 | h | :2 | .timer 1 0 md -h fxctrl 20 33 | h | :3  | h | :4 | td -r fxctrl 36,38
  var %tmp = 0 | while (%tmp < $numtok($fx_ext,35)) { inc %tmp | did -a fxctrl 36 $gettok($fx_ext,%tmp,35) } 
  if ($get_fxcfg(o,jukebox,default)) { did -c fxctrl 34 | td -e fxctrl 35,36,37,38 } | else { td -b fxctrl 35,36,37,38 } 
  if ($get_fxcfg(o,jukebox,folder)) && ($get_fxcfg(o,jukebox,filetype)) { cd fxctrl 36 $get_fxcfg(o,jukebox,filetype)
  if $get_fxcfg(o,jukebox,filetype) { var %~d = $did(36).text | set %ext *. [ $+ [ %~d ] ] | var %t1 = 0 | while (%t1 < $fx_fl(%~d,0)) { inc %t1 | did -a fxctrl 38 $fx_fl(%~d,%t1) } | cd fxctrl 38 $get_fxcfg(o,jukebox,folder) } }
  if $get_fxcfg(o,jukebox,mp3header) { did -c fxctrl 39 } | if $get_fxcfg(o,jukebox,ondoubleclick) == $null { fx_w2 jukebox ondoubleclick 2 } | did -c fxctrl 41 $get_fxcfg(o,jukebox,ondoubleclick) 
  if $get_fxcfg(o,jukebox,amini) { did -c fxctrl 42 } | h
  :5 | :6 | h
  :8 | fxcfg ss | h
  :9 | fxcfg fxsrv | h
  :10 | fxcfg fxgrb | h
  :11 | fxcfg fxsfx | h
  :16 | if (%tmp) { did -r fxctrl 28 | md -v fxctrl 20 33 | did -e fxctrl 18 | did -h fxctrl 33 | get_fxcfg %tmp
    if ($fx_st(%tmp) == on) { md -e fxctrl 21 33 | did -c fxctrl 20 } | else { md -b fxctrl 21 33 | did -u fxctrl 20 }
    if ($fx_rp(%tmp) == on) { did -c fxctrl 21 } | else { did -u fxctrl 21 } 
    if ($fx_pl(%tmp)) { did -ra fxctrl 28 $fx_pl(%tmp) } 
    if ((%tmp != MP3) && (%tmp != WAV) && (%tmp != MID)) { did -b fxctrl 23 }
    if ($fx_plmode(%tmp) == $null) { fx_w3 %tmp plmode 1 } 
    if ($fx_plmode(%tmp) == 0) { did -c fxctrl 23 | td -u fxctrl 24,25 | td -b fxctrl 28,29,30 }
    if ($fx_plmode(%tmp) == 1) { did -c fxctrl 24 | td -u fxctrl 23,25 | td -b fxctrl 28,29,30 }
    if ($fx_plmode(%tmp) == 2) { did -c fxctrl 25 | td -u fxctrl 23,24 | td -e fxctrl 28,29,30 }
    if ($flgrab(%tmp) == $null) { fx_w3 %tmp flgrab $true } | if ($flserv(%tmp) == $null) { fx_w3 %tmp flserv $true } | if ($flap(%tmp) == $null) { fx_w3 %tmp flap $true }
  if ($flgrab(%tmp)) { did -c fxctrl 30 } | else { did -u fxctrl 30 } | if ($flserv(%tmp)) { did -c fxctrl 31 } | else { did -u fxctrl 31 } | if ($flap(%tmp)) { did -c fxctrl 22 } | else { did -u fxctrl 22 } | h } 
  else { md -h fxctrl 20 33 | did -v fxctrl 33 } | h
  :17 | .timer 1 0 ft_add %tmp | h
  :18 | if ((%tmp == MP3) || (%tmp == WAV) || (%tmp == MID)) { fx comply | a %err This file type is a base file type and cannot be removed | h } 
  var %tmp2 = $chr(35) $+ %tmp $+ $chr(35)
  fx_w2 general extensions $remove($fx_ext,%tmp2)
  did -d fxctrl 16 $did(fxctrl,16).sel
  remini $cfgdir_f %tmp | h
  :20 | fxcfg st %tmp | h | :21 | fxcfg rp %tmp | h | :22 | fxcfg ap %tmp | h
  :23 | on | fx_w2 %tmp plmode 0 | td -b fxctrl 28,29,30 | h
  :24 | on | fx_w2 %tmp plmode 1 | td -b fxctrl 28,29,30 | h
  :25 | on | fx_w2 %tmp plmode 2 | td -e fxctrl 28,29,30 | h 
  :26 | fxpp %tmp | h | :27 | fxfp | h | :29 | fxcfg pl %tmp | h
  :30 | unset %adet | dialog -m adet adet | h
  :31 | fxcfg flgrab %tmp | h | :32 | fxcfg flserv %tmp | h
  :34 | if $get_fxcfg(o,jukebox,default) { fx_w2 jukebox default $false | did -b fxctrl 35,36,37,38 } | else { fx_w2 jukebox default $true | did -e fxctrl 35,36,37,38 } | h
  :36 | did -r fxctrl 38 | var %~d = $did(36).text | set %ext [ *. [ $+ [ %~d ] ] ] | var %t1 = 0 | while (%t1 < $fx_fl(%~d,0)) { inc %t1 | did -a fxctrl 38 $fx_fl(%~d,%t1) } | cd fxctrl 38 $get_fxcfg(o,jukebox,folder) | h
  :38 | fx_w2 Jukebox Default $true | fx_w2 Jukebox Filetype $did(36).text | fx_w2 Jukebox Folder $did(38).text | h
  :39 | if ($get_fxcfg(o,jukebox,mp3header)) { off | fx_w2 jukebox mp3header $false } | else { on | fx_w2 jukebox mp3header $true } | h
  :41 | on | fx_w2 jukebox ondoubleclick $did(41).sel | h
  :42 | if ($get_fxcfg(o,jukebox,amini)) { off | fx_w2 jukebox amini $false } | else { on | fx_w2 jukebox amini $true } | h
  :80 | .timer 1 0 mpl | h 
  :82 | set %adet $true | dialog -m adet adet | h
  :84 | on | a Resetted all external players | var %tmp = 0 | while (%tmp < $numtok($fx_ext,35)) { inc %tmp | fx_w2 $gettok($fx_ext,%tmp,35) player $null } | h
  :86 | plgen | h
  :87 | if ($get_fxcfg(o,general,rtrig)) { off | fx_w2 general rtrig $false } | else { on | fx_w2 general rtrig $true } | h
  :496 | run http://www.borgirc.net
  :499 
}

alias ft_add set %extt $?="Add new extension (2-3 characters long)" | if (%extt) ft_add1 $1 %extt
alias ft_add1 if $len(%extt) < 2 || $len(%extt) > 3 { fx comply | a %err File type should be 2 or 3 characters long | h } | fx_w3 general extensions $fx_ext $+ $chr(35) $+ $upper(%extt) $+ $chr(35) | did -a fxctrl 16 $upper(%extt)

on *:dialog:fxctrl:edit:*: var %tmp = $did(fxctrl,16,$did(fxctrl,16).sel).text | goto $did | h | :27 | if ($len($did(27).text) > 3) { fx_w3 %tmp Player $did(27).text } | else { remini $cfgdir_f %tmp Player } | h


alias fxctrl if $dex(fxctrl) { dialog -m fxctrl fxctrl } | else { dialog -a fxctrl }

alias fxss if ($1) { return b } | if $fx_sndsys != on { fx comply | a %err This feature is not available - the sound system has been disabled | h } 
alias _fxss if $fx_sndsys == on { return $true } | else { return $false }
alias fx_extchk var %~tmp = 0 | :loop | inc %~tmp | if %~tmp <= $numtok($fx_ext,35) { if $1 == $gettok($fx_ext,%~tmp,35) { return $true } | goto loop } | return $false

alias get_fxcfg {
  if ($1) {
    if ($1 == g) { return $readini $cfgdir_f General $2 }
    if ($1 == e) {
      if ($2 == st) { return $readini $cfgdir_f $3 Status }
      if ($2 == rp) { return $readini $cfgdir_f $3 Remoteplay }
      if ($2 == pl) { return $readini $cfgdir_f $3 Player }
      if ($2 == plmode) { return $readini $cfgdir_f $3 plmode }
      if ($2 == fl) { if $4 == $null { fx comply | a %err Internal error (get_fxcfg fl) | h }
        var %no = 0 | var %tmp = blah | while (%tmp) { 
          inc %no | var %tmp = $readini $cfgdir_f $3 %no 
          if %tmp == $null { break } 
          var %tmp2 = $gettok(%tmp,1,42)
          if $4 isnum { if $4 == %no && $4 != 0 { return %tmp2 | break } }
          else { $4- %tmp2 }
        } 
        if $4 == 0 { return $calc(%no - 1) }
      }
      if ($2 == grab) { return $readini $cfgdir_f $3 flgrab }
      if ($2 == serv) { return $readini $cfgdir_f $3 flserv }
      if ($2 == ap) { return $readini $cfgdir_f $3 flap }
      if ($2 == vp) { return $readini $cfgdir_f $3 flvp }
      if ($2 == m) { return $readini $cfgdir_f $3 flm }
      if ($2 == vph) { return $readini $cfgdir_f $3 flvph }
      if ($2 == vps) { return $readini $cfgdir_f $3 flvps }
      if ($2 == ctcp) { return $readini $cfgdir_f $3 flctcp }
      var %tmp = $readini $cfgdir_f $2 $3
    if (%tmp) { return %tmp } | else { return $null } }
    if ($1 == o) { var %tmp = $readini $cfgdir_f $2 $3 | return %tmp }
  }
}
alias fx_w1 writeini $cfgdir_f General $1-
alias fx_w2 writeini $cfgdir_f $1-
alias fx_w3 fx_w2 $1-

alias _on fx_w1 $1 on
alias _off fx_w1 $1 off

alias fx_serv if $get_fxcfg(g,fxserv) == on { return on } | else { return off } 
alias fx_grab if $get_fxcfg(g,fxgrab) == on { return on } | else { return off } 
alias fx_sndsys if $get_fxcfg(g,fxsndsys) == on { return on } | else { return off } 
alias fx_sfx if $get_fxcfg(g,fxsfx) == on { return on } | else { return off } 
alias fx_ext return $get_fxcfg(g,Extensions,$1)

alias flpropn var %tmp = $readini $cfgdir_f $1 $2 | return $gettok(%tmp,$3,42)
alias flpropf var %no = 0 | var %tmp = blah | while (%tmp) { inc %no | var %tmp = $readini $cfgdir_f $1 %no | if %tmp == $null { break } | if $gettok(%tmp,1,42) == $3- { return $flpropn($1,%no,$2) } } 

alias snddir return $get_fxcfg(o,soundfx,sounddir)

alias fx_st return $get_fxcfg(e,st,$1)
alias fx_rp return $get_fxcfg(e,rp,$1)
alias fx_pl return $get_fxcfg(e,pl,$1)
alias fx_plmode return $get_fxcfg(e,plmode,$1)
alias fx_fl return $get_fxcfg(e,fl,$1,$2-)
alias fx_fls return $get_fxcfg(e,fls,$1,$2-)
alias flgrab return $get_fxcfg(e,grab,$1)
alias flserv return $get_fxcfg(e,serv,$1)
alias flap return $get_fxcfg(e,ap,$1)
alias flvp return $get_fxcfg(e,vp,$1)
alias flm return $get_fxcfg(e,m,$1)
alias flvph return $get_fxcfg(e,vph,$1)
alias flvps return $get_fxcfg(e,vps,$1)
alias flctcp return $get_fxcfg(e,ctcp,$1)

alias fxcfg {
  if $1 == ss { if ($fx_sndsys == on) { off | _off fxsndsys | md -b fxctrl 9 12 | goto end } | else { on | _on fxsndsys | md -e fxctrl 9 12 | goto end } }
  if $1 == fxgrb { if ($fx_grab == on) { _off fxgrab | off | goto end } | else { _on fxgrab | on | goto end } }
  if $1 == fxsfx { if ($fx_sfx == on) { _off fxsfx | off | goto end } | else { on | _on fxsfx | goto end } }
  if $1 == fxsrv { if ($fx_serv == on) { _off fxserv | .disable #FxServ | off | a %conf [4Off] Sound server disabled - Please note that mIRC sound requests are not handled by the script, but by mIRC. If you want to ignore mIRC !nick sound-gets as well, you'll have to disable it in the Sounds section in mIRC options. (alt+O) | goto end }
  else { _on fxserv | .enable #FxServ | on | a %conf [3On] Sound server enabled - Please note that mIRC sound requests are not handled by the script, but by mIRC. If you want to listen to mIRC !nick sound-goto endts as well, you'll have to enable it in the Sounds section in mIRC options. (alt+O) | goto end } }
  if $1 == pl { .timer 1 0 spl $2- }
  if $1 == loc { .timer 1 0 set % $+ fxloc $!sdir="Location of files" $mircdir $+ sound\ $chr(124) fx_w3 $2 Folders %fxloc if (%mp3dir) a %conf Files location set to:2 $!ifmatch }
  if $1 == st { if $fx_st($2) == off || $fx_st($2) == $null { on | fx_w3 $2 Status on | md -e fxctrl 21 32 | td -b fxctrl 29 | if $len($fx_pl) < 4 { did -b fxctrl 27 } }
  else { off | fx_w3 $2 Status off | md -b fxctrl 21 32 } }
  if $1 == rp { if $fx_rp($2) == off || $fx_st($2) == $null { on | fx_w3 $2 RemotePlay on } | else { off | fx_w3 $2 RemotePlay off } }
  if $1 == flgrab { if ($flgrab($2)) { fx_w3 $2 flgrab $false | off } | else { fx_w3 $2 flgrab $true | on } }
  if $1 == flserv { if ($flserv($2)) { fx_w3 $2 flserv $false | off } | else { fx_w3 $2 flserv $true | on } }
  if $1 == ap { if ($flap($2)) { fx_w3 $2 flap $false | off } | else { fx_w3 $2 flap $true | on } }
  if $1 == vp { if ($flvp($2)) { fx_w3 $2 flvp $false | on | td -b fxpp 5,6 } | else { fx_w3 $2 flvp $true | on | td -e fxpp 5,6 } }
  if $1 == vph { if ($flvph($2)) { fx_w3 $2 flvph $false | off } | else { fx_w3 $2 flvph $true | on } }
  if $1 == vps { if ($flvps($2)) { fx_w3 $2 flvps $false | off } | else { fx_w3 $2 flvps $true | on } }
  if $1 == ctcp { if ($flctcp($2)) { fx_w3 $2 flctcp $false | off } | else { fx_w3 $2 flctcp $true | on } }
  flushini $cfgdir_f
  :end
}

alias spl set %player $dir="Choose location of player" *.exe  | if (%player) fxpl_add $1 %player
alias fxpl_add fx_w3 $1 Player $2- | did -ra fxctrl 28 $2-

alias mpl set %player $dir="Choose location of player" *.exe  | if (%player) mpl2 %player
alias mpl2 { var %no = 0 | while (%no < $numtok($fx_ext,35)) { inc %no | var %tmp = $gettok($fx_ext,%no,35)
  if ((%tmp != wav) && (%tmp != mid)) { fx_w3 %tmp Player $1- | a $upper(%tmp) player set to %c.i2 $+ $1- } }
}

alias ontop return $get_fxcfg(o,jukebox,ontop)
alias jk if ($dex(snd)) { if ($ontop == $null) { fx_w2 jukebox ontop $false } | unset %ext* %tmp* %size %tmm | if ($ontop) { dialog -dmo snd snd } | else { dialog -dm snd snd } } | else { a %not Jukebox is already active | dialog -v snd }
alias fx_sync { if ($fx_serv == on) { .enable #FxServ } | else { .disable #FxServ } }

dialog snd {
  title "BorgIRC Jukebox"
  size -1 -1 245 155
  option dbu
  icon $bico
  text "File type:",1,5 5 23 7,left
  combo 2,28 3 25 90,drop
  text "Folder:",3,60 5 16 7,left
  combo 4,78 3 165 50,drop

  box "",6,-1 13 300 124
  list 7, 1 18 190 100,sort hide

  button "Public play",8,193 18 52 10
  button "Private play",9,193 28 52 10
  button "Public random play",10,193 38 52 10
  button "Private random play",11,193 48 52 10

  button "Stop all sounds",12, 193 68 52 10
  button "Stop waves",13, 193 78 52 10
  button "Stop midi's",14, 193 88 52 10

  text "Name:" ,15,2 114 20 7
  text "N/A",16,30 114 300 7
  text "Info:",17,2 121 15 7
  text "N/A",18,30 121 150 7
  text "Folder info:",19,2 129 45 7
  text "N/A",20,30 129 90 7
  text "",21,-1 178 1 50 7
  text "Please select an extension and a folder.",22,50 60 100 7,center

  text "Initializing jukebox...",23,43 50 50 7, hide
  text "100%",24, 153 50 15 7,right hide
  text "0 0 100",25,43 59 125 10, hide


  icon 495, 107 134 230 25 25,system\gfx\borgirc.png,1
  check "Show on top",496,204 128 50 7
  button "&Help",498,104 140 45 13,disable
  button "&Refresh", 497, 54 140 45 13,ok
  button "&Close", 499, 4 140 45 13,ok
}


on *:dialog:snd:init:0: { 
  var %tmp = MARK: $mdx(MarkDialog,$dname) | var %tmp = $mdx(SetControlMDX,25 progressbar smooth > [ $gdll ] ) | did -a $dname 25 barcolor $rgb(0,0,125) | did -a $dname 25 bgcolor $rgb(face)
  _chkjk | if ($ontop) { did -c snd 496 } | if ($get_fxcfg(o,jukebox,default)) && ($get_fxcfg(o,jukebox,filetype)) && ($get_fxcfg(o,jukebox,folder)) {
    var %~d = $get_fxcfg(o,jukebox,filetype) | cd snd 2 %~d | did -r snd 7 | set %ext *. [ $+ [ %~d ] ] | td -r snd 4 | td -r snd 16,18,20 | td -b snd 497 | md -b snd 8 12 | md -b snd 15 22
    fx_fl %~d did -a snd 4 | cd snd 4 $get_fxcfg(o,jukebox,folder) | did -r snd 7 | set %extdir $did(4).text | _tk | .timer199 1 0.5 _getcache 
  }
}

alias _chkjk { if %ext == $null || %extdir == $null { did -b snd 497 } | var %~a = $remove(%ext,*.) 
  if $1 != -q { var %tmp = 0 | while (%tmp < $numtok($fx_ext,35)) { inc %tmp | if ($fx_st($gettok($fx_ext,%tmp,35)) == on) { did -a snd 2 $gettok($fx_ext,%tmp,35) } }
  unset %tmp* %cubes* %size | if %ext == $null { md -b snd 8 12 | md -b snd 15 22 } }
}

alias snupd did -o snd 25 1 $int($1) | did -o snd 24 1 $1 $+ % | if ($2-) { did -o snd 23 1 $2- }
alias _tk did -h snd 22 | did -v snd 23,24,25 | md -e snd 15 22 | td -r snd 16,18,20 | td -e snd 497 | md -e snd 8 12

on *:dialog:snd:sclick:*: { goto $did
  :0 | h
  :2 | did -h snd 7 | did -v snd 22 | var %~d = $did(2).text | did -r snd 7 | set %ext [ *. [ $+ [ %~d ] ] ] | td -r snd 4 | td -r snd 16,18,20 | td -b snd 497 | md -b snd 8 12 | md -b snd 15 22 | fx_fl %~d did -a snd 4 | h
  :4 | did -rh snd 7 | did -v snd 23,24,25 | set %extdir $did(4).text | _tk | .timer199 1 0.5 _getcache | h
  :7 | var %tmp = $findfile(%extdir,$did(snd,7,$did(snd,7).sel).text,1) | if (mp3 isin %ext) && ($get_fxcfg(o,jukebox,mp3header)) { var %header =  $d($calc($mp3(%tmp).length / 1000)) $mp3(%tmp).bitrate $+ kbps $calc($mp3(%tmp).sample / 1000) $+ khz $mp3(%tmp).mode } | else { unset %header } | did -ra snd 16 %tmp | var %tmp2 = $size($lof(%tmp)) %header | did -ra snd 18 $remove(%tmp2,$l,$l2) | unset %nmp3.* | h
  :8 | pdf | h | :9 | pdf -p | h | :10 | pdf -r | h | :11 | pdf -pr | h | :12 | f8 | h | :13 | splay -w stop | h | :14 | splay -m stop | h
  :22 | md -v snd 1 23 | did -h snd 22 | dialog -bs snd %jk_x %jk_y 245 143 | did -t snd 7 | did -f snd 7 | unset %jk_* | h
  :495 | run http://www.borgirc.net
  :496 | if ($ontop) { off | dialog -n snd |  fx_w2 jukebox ontop $false } | else { on | dialog -o snd | fx_w2 jukebox ontop $true } | h
  :497 | snupd 0 | did -rh snd 7 | did -v snd 23,24,25 | .timer199 1 0.5 _getcache | h | :499
}

on *:dialog:snd:dclick:7: if $get_fxcfg(o,jukebox,ondoubleclick) == $null { fx_w2 jukebox ondoubleclick 2 } | goto $get_fxcfg(o,jukebox,ondoubleclick) | :1 | h | :2 | pdf | h | :3 | pdf -p | h | :4 | pdf -r | h | :5 | pdf -rp | h

alias pdf { if $get_fxcfg(o,jukebox,amini) { dialog -i snd }
  var %tmp1 =  $did(snd,7,$did(snd,7).sel).text 
  if r isin $1 { set -u %tmp0 $rand(1,$did(snd,7).lines) | set -u %tmp1 $did(snd,7,%tmp0).text | if p !isin $1- { set %iif2 [random] } | else { set %iif2 randomly } }
  else { unset %iif2 } 
  if (removed isin %tmp1) { fx comply | a %err File was removed since last refresh | h } 
  if p isin $1 { .fxplay %tmp1 } | else { fxplay %tmp1 }
}
alias lf { var %tmp = $remove(%ext,.,*) | if $flpropf(%tmp,2,%extdir) { set -u %lftmp 0 | set %tot $findfile(%extdir,%ext,0) | set %total $findfile(%extdir,%ext,0,lf2 $1-) }
  else { set -u %lftmp 0 | set %tot $findfile(%extdir,%ext,0,1) | set %total $findfile(%extdir,%ext,0,1,lf2 $1-) }
}
alias lf2 inc %lftmp | did -a snd 7 $nopath($1-) | snupd $round($calc((%lftmp / %tot) * 100),1)
alias _getcache { 
  unset %size | fx proc | lf | did -h snd 23,24,25 | did -v snd 7 
  var %tmp = $remove(%ext,.,*) | var %tmp2 = $calc(1 + $finddir(%extdir,*,0))
  if $flpropf(%tmp,2,%extdir) { did -ra snd 20 $findfile(%extdir,%ext,0) files listed in %tmp2 $iif(%tmp2 < 2,folder,folders) }
  else { did -ra snd 20 $findfile(%extdir,%ext,0,1) files listed in 1 folder }
  unset %cubes* %size | fx compl -n | _chkjk -q | dialog -v snd | h
}

alias fxfp if $dex(fxfp) { dialog -m fxfp fxfp }

dialog fxfp {
  title ""
  size -1 -1 186 104
  option dbu
  icon $bico
  list 1,1 1 151 76,tab3
  button "&Add",2,155 1 30 10,tab3
  button "&Remove",3,155 11 30 10,tab3 disable
  button "&Clear",4,155 31 30 10,tab3
  check "&Process subfolders for this folder",5,1 77 85 7, disable
  check "&Disable serving for this folder",6,1 84 85 7, disable
  button "\/ Find options",7,1 94 40 10
  list 8,1 104 151 72
  text "Ready.",9,1 178 100 7
  button "Scan",10,155 104 30 10,ok

  box "",11, -1 89 200 200 

  text "Search in:",12,1 167 25 7
  combo 13,26 165 60 50,drop
  text "",14,106 167 50 7

  button "Add",97, 155 144 30 10,disable
  button "Add all",98, 155 154 30 10,disable

  button "&OK", 99, 155 65 30 10,ok
}

on *:dialog:fxfp:init:0: { if ($dex(fxctrl)) { fx comply | a %err This dialog can only be opened from the Multimedia system control panel | dialog -x fxfp | h }
  var %tmp = $did(fxctrl,16,$did(fxctrl,16).sel).text | if %tmp == $null { fx comply | a %err Please select a file type | dialog -x fxfp | h }
  chkfp %tmp | td -b fxfp 3,98 | md2 -a fxfp 13 C: drive, D: drive, All fixed drives, All drives | did -c fxfp 13 1
}

alias fx_sfl return $readini $cfgdir_f $1 $2

alias chkfp var %tmp = $did(fxctrl,16,$did(fxctrl,16).sel).text | dialog -t fxfp %tmp Folder properties | var %no0 = 0 | did -r fxfp 1 | fx_fl $1 did -a fxfp 1 
on *:dialog:fxfp:sclick:*: { 
  var %tmp = $did(fxctrl,16,$did(fxctrl,16).sel).text | var %tmp3 = *. $+ %tmp | var %tmp2 = $chr(35) $+ $did(fxfp,1,$did(fxfp,1).sel).text $+ $chr(35) | goto $did
  :0 | h
  :1 | td -e fxfp 3,5,6 | if $flpropn(%tmp,$did(fxfp,1).sel,2) { did -c fxfp 5 } | else { did -u fxfp 5 } | if $flpropn(%tmp,$did(fxfp,1).sel,3) { did -c fxfp 6 } | else { did -u fxfp 6 } | h
  :2 | fxfp_add %tmp | h | :3 | fxfp_rem %tmp | goto 8 | h
  :4 | var %no = 0 | while (%no < $did(1).lines) { inc %no | remini $cfgdir_f %tmp %no } | chkfp %tmp | h
  :5 | fx_w2 %tmp $did(1).sel $puttok($fx_sfl(%tmp,$did(fxfp,1).sel),$iif($did(5).state == 0,$false,$true),2,42) | h 
  :6 | fx_w2 %tmp $did(1).sel $puttok($fx_sfl(%tmp,$did(fxfp,1).sel),$iif($did(6).state == 0,$false,$true),3,42) | h 
  :7 | if $left($did(7).text,2) == \/ { did -ra fxfp 7 /\  Find options | dialog -bs fxfp -1 -1 186 176 } | else { did -ra fxfp 7 \/  Find options | dialog -bs fxfp -1 -1 186 104 } | h
  :8 | td -e fxfp 98 | var %tmp9 = $findfile($did(8,$did(8).sel).text,%tmp3,0,1) | var %tmp10 = $chr(35) $+ $did(8,$did(8).sel).text $+ $chr(35) | did -ra fxfp 14 Found: %tmp9 %tmp $+ $iif(%tmp9 != 1,'s) | var %no = 0 | while (%no < $fx_fl(%tmp,0)) { inc %no | if $fx_fl(%tmp,%no) == %tmp10 { did -b fxfp 97 | h } } | did -e fxfp 97 | h
  :10 | var %tmp2 = $did(13,$did(13).sel).text | did -r fxfp 8 | did -ra fxfp 9 Scanning %tmp2 $+ ... | td -b fxfp 10,98 | dirfind $ck(%tmp2) *. $+ %tmp did -a fxfp 8 | did -e fxfp 10 | did -ra fxfp 9 Ready. | h
  :13 | h
  :97 | unset %addall | fxfp_add2 %tmp $did(8,$did(8).sel).text | h | goto 8 | h
  :98 | var %no = 0 | while (%no < $did(8).lines) { inc %no | set %addall $true | fxfp_add2 %tmp $did(8,%no).text } | goto 8
  :99
}

alias -l fxfp_add .timer 1 0 sfp $1
alias -l sfp set %fxloc $sdir="Add sound folder" | if (%fxloc) fxfp_add2 $1 %fxloc
alias -l fxfp_add2 { var %no = 0 | while (%no < $did(fxfp,1).lines) { inc %no | if $2- == $did(fxfp,1,%no).text { if (%addall != $true) { fx comply | a %err Can't add folder - already exists in list | unset %addall } | return } }
  var %tmp = $2- | fx_w3 $1 $calc($fx_fl($1,0) + 1) %tmp $+ $chr(42) $+ $false $+ $chr(42) $+ $false | did -a fxfp 1 $2- | flushini $cfgdir_f
}

alias fxfp_rem remini $cfgdir_f $1 $did(fxfp,1).sel | chkfp $1
alias fxpp set %ppext $1 | if $dex(fxpp) { dialog -m fxpp fxpp }

dialog fxpp {
  title ""
  size -1 -1 120 75
  option dbu
  icon $bico
  text "" ,1,3 3 50 7
  text "",2,50 3 15 7
  radio "Silent play",3,3 3 50 7
  radio "Verbose play",4,3 10 60 7
  check "Show header info (if available)",5,15 17 120 7
  check "Show filesize",6,15 24 50 7
  check "Broadcast CTCP to target (recommended)",7,3 31 110 7
  text "Publicly play to: ",8,3 45 90 7
  combo 9,46 43 70 50,drop
  button "&Help", 98, 63 61 30 10,ok disable
  button "&Ok", 99, 33 61 30 10,ok
}

on *:dialog:fxpp:init:*: { dialog -t fxpp $did(fxctrl,16,$did(fxctrl,16).sel).text play properties
  if (%ppext == $null) { fx comply | a %err Please open this dialog from the Multimedia system control panel | dialog -x fxpp | h }
  var %tmp1 = Active window | var %tmp2 = All channels
  did -ra fxpp 9 %tmp1 | did -a fxpp 9 %tmp2
  if ($flvp(%ppext) == $null) { fx_w3 %ppext flvp $true } | if ($flvph(%ppext) == $null) { fx_w3 %ppext flvph $true }
  if ($flvps(%ppext) == $null) { fx_w3 %ppext flvps $true } | if ($flctcp(%ppext) == $null) { fx_w3 %ppext flctcp $true }
  if ($flm(%ppext) == $null) { fx_w3 %ppext flm $true }
  if ($flvp(%ppext)) { did -c fxpp 4 } | else { did -c fxpp 3 | td -b fxpp 5,6 }
  if ($flvph(%ppext)) { did -c fxpp 5 }
  if ($flvps(%ppext)) { did -c fxpp 6 }
  if ($flctcp(%ppext)) { did -c fxpp 7 }
  if ($flm(%ppext)) { did -c fxpp 9 1 } | else { did -c fxpp 9 2 }
}

on *:dialog:fxpp:sclick:*: { var %tmp = $did(fxctrl,16,$did(fxctrl,16).sel).text | goto $did
  :3 | :4 | fxcfg vp %tmp | h
  :5 | fxcfg vph %tmp | h
  :6 | fxcfg vps %tmp | h
  :7 | fxcfg ctcp %tmp | h
  :9 | if All isin $did(9).text { on | fx_w3 %tmp flm $false } | else { on | fx_w3 %tmp flm $true } | h
  :99 | :0
}

ctcp ^*:*: { if ((con\con isin $1-) || (\con isin $1-)) || ((con/con isin $1-) || (/con isin $1-)) { h }
  if $target == $me { set -u %tg you | set -u %tmpecho _c2 $nick } | else { set -u %tmpecho e $target | set -u %tg $target } | var %1 = $left($strip($1),15) | var %2 = $2- | var %3 = $2
  if %1 == DCC { goto enddcc }
  if %1 == SOUND {
    if ((%MI.sd == on) && (.mid isin $2-)) { s Ignored incoming MIDI  $+ $2- $+  from  $+ $nick | h }
    if ((%W.sd == on) && (.wav isin $2-)) { s Ignored incoming WAVE  $+ $2- $+  from  $+ $nick | h }
    if ((%gr.flt == on) && ([ %flt. [ $+ [ $nick ] ] ] == on) && ($istok(voyborg1.wav voyborg2.wav locutus.wav weborg.wav,$2,32))) { s %not Filtered BorgIRC auto-greet (Press F3 and go to Misc. settings to disable it) | h }
    if ($2) { if $target == $me { set -u %tg you | set -u %tmpecho _c2 $nick } | else { set -u %tmpecho e $target | set -u %tg $target }
      var %tmp = 0 | while (%tmp < $numtok($fx_ext,35)) { inc %tmp | var %tmp3 = [ *. [ $+ [ $gettok($fx_ext,%tmp,35) ] ] ] | if (%tmp3 iswm $2-) { var %tmp2 = $ifmatch | goto endloop1 } | var %tmp3 = %tmp3 $+ * | if (%tmp3 iswm $2-) { var %tmp2 = $ifmatch | goto endloop1 } } 
      %tmpecho %c.i $+ $nick has played %c.i2 $+ $2- to %tg [unsupported] | goto endctcp 
      :endloop1 | var %tmp2 = $remove(%tmp2,*) | var %snd = $_snd(%2,%tmp2) | var %tmp2 = $remove(%tmp2,.)
      %tmpecho %c.i $+ $nick has played %c.i2 $+ %snd to %tg
      var %tmp = 0 | while (%tmp < $fx_fl(%tmp2,0)) { inc %tmp | if $findfile($fx_fl(%tmp2,%tmp),%snd,1) { var %tmp4 = $ifmatch | goto endloop2 } }
      if (($fx_grab == on) && ($flgrab(%tmp2))) { %tmpecho Requesting %c.i2 $+ %snd from %c.i $+ $nick | .notice $nick !DCCSEND %snd } | goto endsnd
      :endloop2 
      if ($fx_rp(%tmp2) == on) { 
        if ($get_fxcfg(o,general,rtrig)) { a $upper(%tmp2) play triggered by $+ %c.i $nick }
        if ($fx_plmode(%tmp2) == 0) { splay %tmp4 }
        else { run -ns $iif($fx_pl(%tmp2) == 2,$fx_pl(%tmp2)) " $+ %tmp4 $+ " }
        goto endctcp 
      } 
      :endsnd 
    } 
  else { %tmpecho %c.i $+ $nick has played %c.i2 $+ $2- to %tg [unsupported] | goto endctcp } }
  if (($nick != $me) && (%CTCP.prot == on)) { 
    if %s.t == $null { unset %sm.* | set -u10 %s.t on | set %sm. [ $+ [ $site ] ] 1 | goto noiinc }
    set -u10 %s.t on | if %s.t == on { inc [ %sm. [ $+ [ $site ] ] ] 1 }
    :noiinc | if (%sm. [ $+ [ $site ] ] > 4) && (%sm. [ $+ [ $site ] ] < 11) && ($level($address($nick,8)) < 35) { unset %s.t | %tmpecho %alr %c.i $+ $nick caused sound(get) flood - 1 minute ignore | .ignore -tu60 $wildsite $nick | h } 
  if ([ %sm. [ $+ [ $site ] ] ] > 10) && $level($address($nick,8)) >= 35 { unset %sm. [ $+ [ $site ] ] | unset %s.t | %tmpecho %alr %c.i $+ $nick caused sound(get) flood - 5 minutes ignore | .ignore -tu300 $wildsite $nick | h } } 
  if %1 == GET { `sd $2- | h }
  if (($len(%1) == 3) || ($len(%1) == 2)) { if %1 == DO { goto endctcp } | if ($fx_extchk(%1)) { 
      var %9 = [ . [ $+ [ %1 ] ] ] | var %snd = $_snd(%2,%9) 
      if $fx_st(%1) == off || %snd == $null { goto endctcp }
      if $len(%snd) < 5 { %tmpecho %not Invalid sound play from %c.i $+ $nick - $+ %c.i2 $2-  $+ $fm1(ignored) | goto endctcp }
      var %tmp = 0 | %tmpecho %c.i $+ $nick has played %c.i2 $+ %snd to %tg
      while (%tmp < $fx_fl(%1,0)) { inc %tmp | if $findfile($fx_fl(%1,%tmp),%snd,1) { var %tmp2 = $ifmatch | goto endloop0 } }
      if (($fx_grab == on) && ($flgrab(%1))) { %tmpecho Requesting %c.i2 $+ %snd from %c.i $+ $nick | .ctcp $nick %1 $+ GET %snd | goto endsnd0 } | else { goto endctcp }
      :endloop0 
      if (%tmp2) {
        if ($fx_rp(%1) == on) { 
          if ($get_fxcfg(o,general,rtrig)) { a $upper(%1) play triggered by $+ %c.i $nick }
          if ($fx_plmode(%tmp2) == 0) { splay %1 }
          else { run -ns $iif($fx_pl(%1),$fx_pl(%1)) " $+ %tmp2 $+ " }
          goto endctcp
        } 
        :endsnd0 
      } 
    }
  else { fx schqbeep | if ($target == $me) { set -u %tmpp you } | else { set -u %tmpp $target } | a Incoming CTCP $+ %c.i2 $upper(%1) (directed to %tmpp $+ ) from $+ %c.i3 $nick $+ / $+ $site | goto endctcp } }
  if ((*GET iswm %1) && ($len(%1) == 6)) { if ($fx_extchk($left(%1,3))) { var %8 = $left(%1,3) | var %9 = [ . [ $+ [ %8 ] ] ] | var %snd = $_snd(%2,%9) 
      if (($flserv(%8)) && ($fx_st(%8) == on)) { if ($fx_serv == off) { .disable #FxServ | goto endctcp }
        var %tmp = 0 | while (%tmp < $fx_fl(%8,0)) { inc %tmp | if $findfile($fx_fl(%8,%tmp),%snd,1) { var %tmp2 = $ifmatch | goto endloop } }
        .notice $nick The specified file  $+ $nopath(%snd) $+  does not exist. | s Denied sound request from %c.i $+ $nick - $+ %c.i2 %snd [does not exist] | h
        :endloop | if (%tmp2) { if ($flpropf(%8,3,$nofile(%tmp2))) { s Denied sound request from %c.i $+ $nick - $+ %c.i2 %snd [Serving for this folder has been disabled] | h }
    s Acknowledging $upper(%8) request from $+ %c.i $nick - %snd | .notice $nick Now sending you  $+ %snd $+  | var %sendfile = " $+ %tmp2 $+ "  | dcc send $nick %sendfile | goto endctcp } | h } }
  else { .notice $nick No support for the specified sound type. | s Denied sound request from %c.i $+ $nick [unsupported] | h } }
  :endctcp | hdef | h | :enddcc
}

#FxServ on
ON *:TEXT:*:*: fxss -c | if !* iswm $1- && $remove($1,$chr(33)) == $me { var %2 = $2- | `sd $2- }
ON *:NOTICE:*:?: fxss -c | if !DCCSEND* iswm $1- { `sd $2- }

alias `sd {
  if ((con\con isin $1-) || (\con isin $1-)) || ((con/con isin $1-) || (/con isin $1-)) { fx borgalrt | a %alr %c.i $+ $nick attempted to crash your system with the /con/con exploit! User ignored for 5 minutes. | .ignore -tu300 $wildsite $nick | h } 
  if %sd.t == $null { unset %sdc.* | set -u10 %sd.t on | set %sdc. [ $+ [ $site ] ] 1 | goto noincc } | set -u10 %sd.t on | if %sd.t == on { inc [ %sdc. [ $+ [ $site ] ] ] 1 } | :noincc | if ([ %sdc. [ $+ [ $site ] ] ] > 5) { closemsg $nick | fx security | a %warn Sound request flood detected from $+ %c.i $nick $+ / $+ $site - 2 minutes ignore | .ignore -cu120 $wildsite $nick | h } | if ([ %sdc. [ $+ [ $site ] ] ] > 4) { closemsg $nick | fx security | a %warn Sound request flood detected from $+ %c.i $nick $+ / $+ $site - 30 minutes ignore | .ignore -cu1800 $wildsite $nick | unset %dc.* %d.t | h } 
  var %tmp = 0 | while (%tmp < $numtok($fx_ext,35)) { inc %tmp | var %tmp3 = [ *. [ $+ [ $gettok($fx_ext,%tmp,35) ] ] $+ * ] | if (%tmp3 iswm $1-) { var %tmp2 = $ifmatch | goto endloop0 } }
  .notice $nick No support for the specified sound type. | s Denied sound request from %c.i $+ $nick [unsupported] | h 
  :endloop0 | var %8 = $remove(%tmp2,.,*) | var %2 = $1- | var %9 = [ . [ $+ [ %8 ] ] ] | var %snd = $_snd(%2,%9) 
  if (($fx_st(%8) == on) && ($flserv(%8))) {
    var %tmp = 0 | while (%tmp < $fx_fl(%8,0)) { inc %tmp | if $findfile($fx_fl(%8,%tmp),%snd,1) { var %tmp2 = $ifmatch | goto endloop } }
    .notice $nick The specified file  $+ $nopath(%snd) $+  does not exist. | s Denied sound request from %c.i $+ $nick ( $+ %snd $+ ) - [does not exist] | h
    :endloop | if (%tmp2) { if ($flpropf(%8,3,$nofile(%tmp2))) { s Denied sound request from %c.i $+ $nick ( $+ %snd $+ ) - [Serving for this folder has been disabled] | h }
  s Acknowledging $upper(%8) request from $+ %c.i $nick - %snd | .notice $nick Now sending you  $+ %snd $+  | var %sendfile = " $+ %tmp2 $+ "  | dcc send $nick %sendfile | h } }
  h 
}
#FxServ End

alias fx.c return $readini $cfgdir_f $1-
alias dtob { unset %n.dectobin | if ($1) { %decnum = $1 | %dtob = 256 | :start | %dtob = %dtob / 2 | if ($calc(%decnum - %dtob) > -1) { %n.dectobin = %n.dectobin $+ 1 | %decnum = %decnum - %dtob } | else { %n.dectobin = %n.dectobin $+ 0 } | if (%dtob > 1) goto start | return %n.dectobin } }

alias dccstats { 
  var %tmp = 0 | var %bandwidth = 0 | while (%tmp <= $send(0)) { inc %tmp | if $send(%tmp).cps { var %bandwidth = $calc(%bandwidth + $send(%tmp).cps) } }
  var %tmp = 0 | while (%tmp <= $get(0)) { inc %tmp | if $get(%tmp).cps { var %bandwidth = $calc(%bandwidth + $get(%tmp).cps) } }
  ma DCC Status - Bandwidth in use: $round($calc(%bandwidth / 1024),1) kb/s in $send(0)  $+ $iif($send(0) != 1,sends,send) & $get(0) get $+ $iif($get(0) != 1,s)
}

alias pfxplay .fxplay $1-

alias fxplay { if (($show) && ($server == $null)) { pfxplay $1- | return } | if (($show) && ($active == Status window)) { pfxplay $1- | return } 
  fxss 
  if $left($right($1-,5),1) == $chr(46) { var %8 = $right($1-,4) }
  if $left($right($1-,4),1) == $chr(46) { var %8 = $right($1-,3) }
  if $left($right($1-,3),1) == $chr(46) { var %8 = $right($1-,2) }
  if %8 == $null { fx comply | a %err Extension missing | h } 
  if $fx_extchk(%8) == $false || $fx_st(%8) != on { fx comply | a %err Please setup your %8 configuration first in the control panel. F4 > File types | h }
  if %tmp == $false { h } 
  if $1- == $null { var %temp = $$file="Choose your sound file" [ $fx_fl(%8,1) $+ *.%8 ] } 
  else { var %temp = $1- } 
  var %tmp = 0 | while (%tmp < $fx_fl(%8,0)) { inc %tmp | if $findfile($fx_fl(%8,%tmp),%temp,1) { var %temp = $ifmatch | goto endloop } }
  fx comply | a %err File not found - %temp | h
  :endloop
  if $show { if %8 == mp3 { plmp3 %temp | h } | if %8 == wav { wav %temp | h } | if %8 == mid { mid %temp | h } }
  else { if %8 == mp3 { .plmp3 %temp | h } | if %8 == wav { .wav %temp | h } | if %8 == mid { .mid %temp | h } }
  set %exec.time $ticks | var %temp1 = " $+ %temp $+ " | splay stop | run -ns $iif($fx_pl(%8),$fx_pl(%8)) %temp1
  else { unset %iif } 
  if ($flvps(mid)) { var %size = $l $+ $size($lof(%temp)) $+ $l } | else { unset %size }
  if ($flm(%8)) { var %tmp0 = .ctcp $active } | else { var %tmp0 = .mctcp }
  if (($show) && ($flctcp(%8))) { %tmp0 $upper(%8) $remove($nopath(%temp),$chr(35)) }
  if ($flvp(%8)) { if ($show) {  if (($fx_serv == on) && ($flctcp(%8))) { var %tmp = ! $+ $me } | else { unset %tmp } 
    $iif($flm(%8),ma,amsg) $l $+ $upper(%8) $+ $l %tmp $nopath(%temp) %size %iif2 }
  else { a -c6 You are %iif2 playing $nopath(%temp) %size privately } }
  unset %iif2
}

alias plgen { 
  if ($os == ME) { fx comply | a %err The playlist generator is not available with Windows Millenium. Dit heeft te maken met een fout in Windows Millenium. | h }
  .ddeserver on borgirc_uk
  if ($dex) { dl.open plgen | if ($isdde(idx) == $false) { run -ns $mircexe -i $+ $mrcdir $+ idx.ini } 
  }
}

dialog plgen {
  title "Playlist generator"
  size -1 -1 190 76
  option dbu
  icon $bico
  box "",1,1 1 188 24
  radio "Single extension",2,3 6 50 10 6, group
  radio "Multiple extensions (all)",3, 3 16 70 6, disable
  combo 4,160 5 25 100,drop
  box "",5,1 21 188 24
  radio "Single folder",6,3 25 50 10 6, group
  radio "Multiple folders (all)",7, 3 35 70 6, disable
  combo 8,90 25 95 100,drop

  check "Size",10, 50 46 19 7
  check "Time",11, 75 46 21 7
  check "Kbps",12, 100 46 21 7
  check "Khz",13, 125 46 19 7

  button "&Generate", 99, 60 65 30 10,ok
  button "&Cancel",100, 100 65 30 10,cancel
}

alias -l pl_00 { did -r plgen 4 | var %tmp = 0 |  while (%tmp < $numtok($fx_ext,35)) { inc %tmp | did -a plgen 4 $gettok($fx_ext,%tmp,35) }
  var %tmp = 0 | while (%tmp < $did(4).lines) { inc %tmp | if ($did(4,%tmp).text == $pl_lastext) { did -c plgen 4 %tmp | goto endloop } }
  :endloop | .timer 1 0 pl_ddesync
}


alias -l pl_01 { did -r plgen 8 | var %tmp = 0 | while (%tmp < $fx_fl($pl_lastext,0)) { inc %tmp | did -a plgen 8 $fx_fl($pl_lastext,%tmp) }
  var %tmp = 0 | while (%tmp < $did(8).lines) { inc %tmp | if ($did(8,%tmp).text == $pl_lastfolder) { did -c plgen 8 %tmp | goto endloop1 } }
  :endloop1 | if ($did(4).text != MP3) { td -b plgen 10,11,12,13 } | else { td -e plgen 10,11,12,13 }
  .timer 1 0 pl_ddesync
} 

alias pl_ddesync _idx set % $+ ext *. $+ $did(plgen,4).text | _idx set % $+ extdir $did(plgen,8).text

on *:dialog:plgen:init:0: { if ($dex(snd) == $false) { dialog -x snd }
  if ($pl_extmode) { did -c plgen 2 | pl_00 } 
  if ($pl_extmode != $true) { did -c plgen 3 | did -b plgen 4 } 
  if ($pl_foldermode) { did -c plgen 6 | pl_01 }
  else { did -c plgen 7 | did -b plgen 8 }
if ($pl_size) { did -c plgen 10 } | if ($pl_time) { did -c plgen 11 } | if ($pl_kbps) { did -c plgen 12 } | if ($pl_khz) { did -c plgen 13 } }

on *:dialog:plgen:sclick:*: { goto $did
  :0 | h
  :2 | pl_mod extmode $true | did -e plgen 4 | pl_00 | h | :3 | pl_mod extmode $false | did -b plgen 4 | h
  :4 | pl_mod lastext $did(4).text | pl_mod lastfolder $fx_fl($did(plgen,4).text,1) | pl_01 | h
  :6 | pl_mod foldermode $true | did -e plgen 8 | pl_01 | h | :7 | pl_mod foldermode $false | did -b plgen 8 | h
  :8 | pl_mod lastfolder $did(8).text | pl_ddesync | h
  :10 | if ($pl_size) { pl_mod size $false | h } | else { pl_mod size $true | h }
  :11 | if ($pl_time) { pl_mod time $false | h } | else { pl_mod time $true | h }
  :12 | if ($pl_kbps) { pl_mod kbps $false | h } | else { pl_mod kbps $true | h }
  :13 | if ($pl_khz) { pl_mod khz $false | h } | else { pl_mod khz $true | h }
  :99 | if ($pl_extmode) && ($pl_foldermode) { dialog -x plgen | .timer 1 0 sidx1 } | h | :100 | dialog -x plgen | _idx exit | h
}

alias sidx1 _idx nick $me | _idx pl

alias pl_extmode return $readini $cfgdir_f Playlist ExtMode
alias pl_foldermode return $readini $cfgdir_f Playlist FolderMode
alias pl_size return $readini $cfgdir_f Playlist Size
alias pl_time return $readini $cfgdir_f Playlist Time
alias pl_kbps return $readini $cfgdir_f Playlist Kbps
alias pl_khz return $readini $cfgdir_f Playlist Khz
alias pl_lastext return $readini $cfgdir_f Playlist LastExt
alias pl_lastfolder return $readini $cfgdir_f Playlist LastFolder
alias pl_mod writeini $cfgdir_f Playlist $1-

alias _idx dde idx command "" // $+ $1-
alias _idx2 dde borgirc_uk command "" // $+ $1-

alias pl { set %t1 $pl_time | set %t2 $pl_kbps | set %t3 $pl_khz | set %t4 $pl_size
  if %ext == $null || %extdir == $null { fx comply | a %err This alias can only be called from the BorgIRC jukebox | h }
  _idx2 a Generating playlist for %extdir $+ , matching files with the %ext extension. This can take a moment.
  window -ash @fxtmp
  set %'tmp 0
  set %total $findfile(%extdir,%ext,0)
  pbar Playlist generation
  pupd 0 Generating playlist...
  var %temp = $findfile(%extdir,%ext,0,pl1 $1-)
  set %temp2 " $+ $mircdirPlaylists\ $+ $me $+ $chr(95) $+ $upper($remove(%ext,*.)) $+ .txt $+ "
  write -c %temp2 BorgIRC Playlist - Generated on: $asctime
  write -a %temp2 Please turn off 'word wrap' to view its contents properly.
  write -a %temp2 Total files listed: %total 
  write -a %temp2 $chr(160)
  write -a %temp2 To request these files, paste the '! $+ $me filename.mp3' part into the channel.
  write -a %temp2 $chr(160)
  write -a %temp2 File name $+ $str($chr(160),72) File info
  write -a %temp2 $str(-,114)
  savebuf -a @fxtmp %temp2
  window -c @fxtmp 
  pkill
  var %temp2 = $remove(%temp2,$chr(34))
  _idx2 a Succesfully created %temp2 - Size: $file(%temp2).size bytes 
  .timer 1 1 exit
}

alias pl1 {
  inc %'tmp 
  pupd $round($calc((%'tmp / %total) * 100),1) 
  var %tmp2 = $size($file($1-).size)) 
  if %tmp2 == $null { var %tmp2 = 0 bytes }
  var %win.tmp = $chr(33) $+ $me $nopath($1-) $+ $str($chr(46),$calc(85 - $len($nopath($1-)))) $chr(91) $iif(%t4,%tmp2)
  if (%ext == *.mp3) && ((%t1) || (%t2) || (%t3)) { 
    if (%t1) { 
      var %1 = $d($calc($mp3($1-).length / 1000))
    } 
    if (%t2) { 
      var %2 = $mp3($1-).bitrate $+ kbps
    } 
    if (%t3) { 
      var %3 = $calc($mp3($1-).sample / 1000) $+ khz 
    } 
    var %win.tmp = %win.tmp %1 %2 %3 
  } 
  aline -l @fxtmp %win.tmp $chr(93) 
}

alias plad ma 9,1Type @ $+ %pl.nick $+ - $+ %pl.ext to get my $upper(%pl.ext) playlist with %pl.files files!

dialog adet {
  title "Auto-detect player"
  size -1 -1 187 96
  option dbu
  icon $bico
  list 1,1 1 151 76,tab3

  button "&Scan",2,155 1 30 10,tab3
  list 3,1 104 151 72

  text "Search in:",4,1 77 25 7
  combo 5,26 75 60 50,drop
  text "Ready.",6,1 87 100 7

  text "",10,106 167 50 7

  button "&Select", 98, 155 55 30 10,ok disable
  button "&Cancel", 99, 155 65 30 10,cancel
}

on *:dialog:adet:init:0: md2 -a adet 5 C: drive, D: drive, All fixed drives, All drives | did -c adet 5 1
on *:dialog:adet:sclick:*: { var %tmp = $did(fxctrl,16,$did(fxctrl,16).sel).text | var %tmp2 = $did(adet,1,$did(adet,1).sel).text | goto $did
  :1 | did -e adet 98 | h
  :2 | adetscan | h
  :5 | h
  :98 | if (%adet) { var %tmp = 0 | while (%tmp < $numtok($fx_ext,35)) { inc %tmp | fx_w2 $gettok($fx_ext,%tmp,35) player %tmp2 } }
  else { fx_w2 %tmp player %tmp2 | did -ra fxctrl 27 %tmp2 } | dialog -x adet | h
  :99 
}

alias adetscan { did -r adet 1
  did -a adet 6 Searching for Winamp... | yy winamp.exe 
  did -ra adet 6 Searching for Windows Media player 6.x... | yy mplayer2.exe
  did -ra adet 6 Searching for Windows Media player 7.x... | yy wmplayer.exe
  did -ra adet 6 Searching for Sonique... | yy sonique.exe
  did -ra adet 6 Searching for K-Jofol... | yy kjofol.exe
  did -ra adet 6 Ready.
  did -e adet 3 
}
alias yy find $ck($did(adet,5,$did(adet,5).sel).text)) $1 m_add $ $+ 1-

alias pl_search {
  if $disk(c).type == fixed { var %tmp = $findfile(c:\,$1,0,m_add $1-) }
  if $disk(d).type == fixed { var %tmp = $findfile(d:\,$1,0,m_add $1-) }
  if $disk(e).type == fixed { var %tmp = $findfile(e:\,$1,0,m_add $1-) }
  if $disk(f).type == fixed { var %tmp = $findfile(f:\,$1,0,m_add $1-) }
  if $disk(g).type == fixed { var %tmp = $findfile(g:\,$1,0,m_add $1-) }
}
alias m_add did -a adet 1 $1- 

; drv_find -af *.mp3 1 a $1-
alias find {
  if $1 == -fc { var %tmp = $findfile(c:\,$2,0,$3-) }
  if $1 == -fd { var %tmp = $findfile(d:\,$2,0,$3-) }
  if $1 == -faf { var %tmp = c d e f g h i j k l m n o p q r s t u v w x y z | var %no = 0 
  while (%no < 24) { inc %no | var %tmp2 = $gettok(%tmp,%no,32) | var %tmp3 = %tmp2 $+ :\ | if $disk(%tmp2).type == fixed { var %tmp_ = $findfile(%tmp3,$2,0,$3-) } } }
  if $1 == -fad { var %tmp = a b c d e f g h i j k l m n o p q r s t u v w x y z | var %no = 0 
  while (%no < 26) { inc %no | var %tmp2 = $gettok(%tmp,%no,32) | var %tmp3 = %tmp2 $+ :\ | if $disk(%tmp2) { var %tmp_ = $findfile(%tmp3,$2,0,$3-) } } }

  if $1 == -dc { var %tmp = $finddir(c:\,$2,0,$3-) }
  if $1 == -dd { var %tmp = $finddir(d:\,$2,0,$3-) }
  if $1 == -daf { var %tmp = c d e f g h i j k l m n o p q r s t u v w x y z | var %no = 0 
  while (%no < 24) { inc %no | var %tmp2 = $gettok(%tmp,%no,32) | var %tmp3 = %tmp2 $+ :\ | a $disk(%tmp2).type %tmp3 | if $disk(%tmp2).type == fixed { var %tmp_ = $finddir(%tmp3,$2,0,$3-) } } }
  if $1 == -dad { var %tmp = a b c d e f g h i j k l m n o p q r s t u v w x y z | var %no = 0 
  while (%no < 26) { inc %no | set %tmp2 $gettok(%tmp,%no,32) | var %tmp3 = %tmp2 $+ :\ | if $disk(%tmp2) { set %tmp_ $finddir(%tmp3,$2,0,$3-) } } }
}

alias dirfind window -ah @temp | find $1 $2 dirfind_a $ $+ nofile($ $+ 1-) | var %tmp = 0 | while (%tmp < $line(@temp,0)) { inc %tmp | $3- $line(@temp,%tmp) } | window -c @temp
alias dirfind_a if $line(@temp,$line(@temp,0)) != $1- { if ($1-) { echo @temp $1- } }

alias ck if $1 == C: drive { return -fc } | if $1 == D: drive { return -fd } | if $1 == All fixed drives { return -faf } | if $1 == All drives { return -fad }

alias fx {
  if ($1 == $null) { a %err Internal error in /fx: no parameter defined | h }
  if (($fx_sfx == on) && ($fx_sndsys == on)) { 
    if (($inwave) && ($2 != -n)) { goto end }
    var %tmp = $mircdir $+ system\sound\ $+ $1 $+ .wav 
    if $1 == pager { var %tmp = $getcfg(aw.p.s) } 
    if ($exists(%tmp)) { splay -w stop | .splay $fxdir $+ $1 $+ .wav } 
    elseif ($1 == pager) { s %err Could not play pager sound - file does not exist }
  }
  :end
  return
}

alias efx var %tmp = $mircdir $+ system\sound\ $+ $1 $+ .wav | if ($exists(%tmp)) { splay -w stop | .splay $fxdir $+ $1 $+ .wav }

alias sp { 
  if $1 == $null { a %err No system sound specified | h } 
  if (($fx_sfx == on) && ($fx_sndsys == on)) { var %no = 0 | while (%no < $fx_fl(wav,0)) { inc %no | var %tmp = $fx_fl(wav,%no) $+ $1 $+ .wav | if ($exists(%tmp))  { .sound # %tmp | return } } } 
}
