; BorgUpdate UK v1.11 for BorgIRC 2.2.0066 or higher - Standalone use only
; Powered with mUnzip by Kamek
; File date: 31-01-2003
; ---------------------------------------------------------------------------------

alias -l blogo return 14[BorgUpdate14]
alias -l bver return $readini($cfgfil,general,bupdate)
alias -l sockwrite ms out > $1- | sockwrite $1-

ON *:START: {
  if ($os != ME) { .ddeserver on bupdate_uk }
  unsetall
  cfgw2 general BUpdate 1.11
  cfgw2 general lastup $ctime
  var %temp = $gettok($getccfg(general,bupdate.host),1,32)
  if (%temp == $null) || (%temp < 1) || (%temp > 3) { cfgw2 general BUpdate.host 1 | %temp = 1 }
  goto %temp
  :1 | %host = www.geocities.com/borgirc | goto end
  :2 | %host = www.borgirc.net | goto end
  :3 | %host = $gettok($getccfg(general,bupdate.host),2,32)
  :end
   .timerwinchk 0 0.5 winchk
  dl.open bchk
}

alias winchk if ($appstate != tray) { showmirc -t }

dialog bchk {
  title "BorgUpdate UK"
  size -1 -1 175 73
  option dbu
  icon "system\gfx\bupdate.ico"
  text "",1,1 3 170 7,center
  text "Waiting for initialization...",2,1 31 170 14,center
  text "BorgUpdate is determining if there are updates available for BorgUpdate.",3,1 13 170 14,center
  box "",4,-1 25 200 30
  text "0 0 100",5, 28 48 120 4,center hide disable
  button "&Cancel", 499, 69 58 35 13,ok
}

on *:dialog:bchk:init:*: { 
  mdx MarkDialog $dname
  mdx SetFont $dname 1 14 900 arial
  mdx SetControlMDX 5 progressbar smooth > [ $gdll ] 
  did -ra bchk 1 BorgUpdate UK version: $bver
  download $gettok(%host,1,47) $gettok(%host,1,47) $gettok(%host,2,47) $+ /bupdate/bupdate_uk.inf bchk_proc bchk_err bchk_end
} 

on *:dialog:bchk:sclick:499: { 
  dialog -x bchk
  unset %data.dload*
  exit
}


alias -l bupd_proc {
  if ($1 == $null) || ($1 != -d) { inc %bupd }
  if (%bupd > 5) { goto 7 }
  goto %bupd
  :1 | did -ra bchk 2 Attempting to connect to BorgUpdate server... | return
  :2 | did -ra bchk 2 Found BorgUpdate server; waiting for reply... | return
  :3 | did -ra bchk 2 Connected to BorgUpdate server. | return
  :4 
  if ($did(bchk,5).visible == $false) { did -v bchk 5 | did -e bchk 5 }
  did -o bchk 5 1 $int($calc(($2 / $3) * 100))
  did -ra bchk 2 Downloading update ( $+ $iif($2 > 0,$2,0) $+ / $+ $3 bytes $+ )
  return
  :5 | did -b bchk 5 | did -h bchk 5 | did -ra bchk 2 Received update from BorgUpdate server | return
  :6 | a Internal error! Script halted. (flags: $1- $+ ) | h
}

alias -l bchk_proc {
  if ($1 == $null) || ($1 != -d) { inc %bchk }
  goto %bchk
  :1 | did -ra bchk 2 Attempting to connect to BorgUpdate server... | return
  :2 | did -ra bchk 2 Found BorgUpdate server; waiting for reply... | return
  :3 | did -ra bchk 2 Connected to BorgUpdate server. | return
  :4 | did -ra bchk 2 Downloading package: $iif($2 > 0,$2,0) bytes | return
  :5 | did -ra bchk 2 Package successfully received | return
  :6 | s Internal error! Script halted. (flags: $1- $+ ) | h
}

alias -l bchk_err {
  did -ra bchk 2 $2-  
  timertimeout $+ $1 off
  if ($sock($1)) { sockclose $1 }
  did -ra bchk 499 &Sluiten | h
}


; Update controle voor BorgUpdate zelf
alias -l bchk_end {
  if ($isfile($1-)) { did -ra bchk 2 Searching for updates... } | else { bchk_err no_sock Internal error in module (bchk_end) }
  if ($read($1-,s,version) > $bver) { 
    did -ra bchk 2 An update for BorgUpdate is available. One moment please.
    .timerwait 1 3 download $gettok(%host,1,47) $gettok(%host,1,47) $gettok(%host,2,47) $+ /bupdate/ $+ $read($1-,s,file) bupd_proc bchk_err bupd_end
  }
  else {
    did -ra bchk 1 BorgIRC version: $borgver
    did -ra bchk 3 BorgUpdate will now determine if there is an update available for BorgIRC
    did -ra bchk 2 One moment please.
    .timerwait 1 3 download $gettok(%host,1,47) $gettok(%host,1,47) $gettok(%host,2,47) $+ /bupdate/borgirc2_uk.inf dummy bchk_err updchk_end
  }
}

alias updchk_end {
  if ($exists($1-)) { did -ra bchk 2 Searching for updates... } | else { bchk_err no_sock Internal error in module (updchk_end) }
  if ($read($1-,s,version) > $borgver) { 
    var %no = 2
    while ($read($1,s,updfile,%no)) {
      inc %no
      var %in = $ifmatch
      if ($borgver == $gettok(%in,1,32)) { 
        did -ra bchk 2 There is an update available for BorgIRC. One moment please.
        unset %bchk
        if ($gettok(%in,2,32) == $null) { goto end }
        a download $gettok(%host,1,47) $gettok(%host,1,47) $gettok(%host,2,47) $+ /bupdate/ $+ $gettok(%in,2,32) bupd_proc bchk_err upd_end
        .timerwait 1 3 download $gettok(%host,1,47) $gettok(%host,1,47) $gettok(%host,2,47) $+ /bupdate/ $+ $gettok(%in,2,32) bupd_proc bchk_err upd_end
        h
      }
    }
    var %noupd = $true
    did -ra bchk 2 There are no updates available for your copy of BorgIRC. You have to download a newer version from the BorgIRC website.
  }
  :end
  did -ra bchk 3 | did -ra bchk 499 &Sluiten 
  if (%noupd != $true) { did -ra bchk 2 There are currently no updates available for BorgIRC. }
  h
}


alias -l dummy return

alias -l bupd_end {
  did -ra bchk 2 An update is being installed. One moment please.
  .echo -q $dll($unzdll, Unzip, -od $1- " $+ $mircdir $+ ")
  if (%errorflag) { bchk_err no_sock De update is corrupt. Probeert u het later nog eens. }
  did -ra bchk 2 Update succesfully installed. BorgUpdate needs to be restarted.
  did -ra bchk 499 &Sluiten | h

}

alias -l upd_end {
  did -ra bchk 2 An update is being installed. One moment please.

  .echo -q $dll($unzdll, Unzip, -od $1- " $+ $mircdir $+ ")
  if (%errorflag) { bchk_err no_sock The update is corrupt. Please try again later. }

  if ($os == ME) { write -a $indir $+ bupdate.tmp BorgUpdate flag }
  elseif $isdde(borgirc_uk) { 
    sdde linesep -s
    sdde echo -s BorgUpdate DDE Connection established.
    sdde .reload -rs $mrcdir $+ bupdatescr.mrc 1
    sdde do.upgrade
    h
  }
  finish
}

alias finish {
  did -ra bchk 3 | did -ra bchk 2 Update succesfully installed.
  did -ra bchk 499 &Sluiten | h
}

alias -l sdde dde borgirc_uk command "" // $+ $1-

alias download {
  reset.dwn
  if ($1 == $null) { fx comply | a $blogo Error processing internal command. Script halted. (download module - no parameters given) | h }
  var %d.id = $r(1,999999)
  set %data.dload. [ $+ [ %d.id ] ] $1-
  $4
  sockopen dload. $+ %d.id $gettok($1,1,47) 80 
}

alias -l gd return $gtok(%data. [ $+ [ $1 ] ],$2)

on *:sockopen:dload*:{
  var %dta = %data. [ $+ [ $sockname ] ]
  .timertimeout $+ $sockname 1 30 timeout $gtok(%dta,5) $sockname
  if ($sockerr) { $gtok(%dta,5) $sockname Error $sockerr while connecting to the BorgUpdate server. $x $+ The server might be temporary unavailable. Please try again later. }
  $gtok(%dta,4,32)
  getfile $gtok(%dta,2) $gtok(%dta,3)
}

on *:sockread:dload*: {
  var %dta = %data. [ $+ [ $sockname ] ]
  var %file = $gettok($gtok(%dta,3),$numtok($gtok(%dta,3),47),47)
  .timertimeout $+ $sockname off
  if (%rcv.hdr) { goto readfile }
  sockread -n &input | var %1 = $bvar(&input,1-2048).text

  if ($left(%1,8) == HTTP/1.1) { 
    if (200 isin %1) { $gtok(%dta,4,32) }
    else {
      $gtok(%dta,5) $sockname Error $gtok(%1,2) - $httperr($gtok(%1,2)) while conecting to the BorgUpdate server. $x $+ The server might be temporary unavailable. Please try again later.
      h
    }
  } 
  while ($sockbr > 0) { 
    if (%rcv.hdr == $null) { 
      sockread -n &input | var %1 = $bvar(&input,1-2048).text
      if (Length isin %1) { set %fil.size $gtok(%1,2) }
      if (%1 == $null) { %rcv.hdr = $true | $gtok(%dta,4) | write -c $indir $+ %file | %rvcd = 0 }
    }  
    :readfile
    if (%rcv.hdr) { 
      sockread &input | var %1 = $bvar(&input,4096).text
      ;      ms %1
      var %loc = $indir $+ %file
      bwrite %loc  -1 &input
      inc %rcvd $sockbr 
      $gtok(%dta,4) -d %rcvd %fil.size
      if (%rcvd >= %fil.size) { 
        $gtok(%dta,4) %file 
        sockclose $sockname
        ;s Saved file to: %loc 
        $gtok(%dta,6) %loc
      }
    }
  }
  :end
}



on *:sockclose:dload*: a sockclose: $sockname

alias -l timeout {
  $1- Timeout while connecting to the BorgUpdate server. Your internet connection or the server may be down. Please try again later.
}

alias -l getfile {
  sockwrite -n dload* GET $iif($left($2,1) != /,/ $+ $2,$2) HTTP/1.1
  sockwrite -n dload* Accept: */*
  sockwrite -n dload* Accept-Language: nl
  sockwrite -n dload* Accept-Encoding: gzip, deflate
  sockwrite -n dload* User-Agent: BorgUpdate/1.1
  sockwrite -n dload* Host: $gettok($1,1,47)
  sockwrite -n dload* Connection: Keep-Alive
  sockwrite dload* $crlf
}

on *:signal:*: { 
  a sig: $signal s1: $1-
  var %tmp = End-of-central-directory signature not found
  if (%tmp isin $1-) { a trig |  %errorflag = $true }
}


alias -l httperr {
  goto $$1 | :302 | return Internal server error | :400 | return Bad request | :401 | return Unauthorized | :402 | return Payment Required | :403 | return Forbidden | :404 | return Not found | :405 | return Method Not Allowed | :406 | return Not Acceptable | :407 | return Proxy Authentication Required | :408 | return Request Timeout
  :409 | return Conflict | :410 | return Gone | :411 | return Length Required | :412 | return Preocondition Failed | :413 | return Request Entity too Large | :414 | return Request-URI Too Long | :415 | return Unsupported Media Type | :416 | return Requested Range not Satisfiable | :417 | return Expectation Failed
  :500 | return Internal Server Error | :501 | return Not Implemented | :502 | return Bad Gateway | :503 | return Service Unavailable | :504 | return Gateway Timeout | :505 | return HTTP Version Not Supported
}

alias -l gtok return $gettok($1,$2,32)
alias -l reset.dwn unset %current.mod %total.mod %rcvd %rcv.hdr | %mod.dwn = $false | sockclose dload*
