
; BorgIRC 2.2 UK core 
; -------------------------------------

alias d return $remove($replace($duration($1-),secs,sec,sec,s,mins,min,min,m,hrs,hr,hr,h),$chr(32)) 
alias size if $1 >= 1000000000 { return $round($calc($1 / 1024000000),2) $+ gb } | if $1 >= 1000000 { return $round($calc($1 / 1024000),2) $+ mb } | if $1 < 1000000 && $1 >= 10000 { return $round($calc($1 / 1024),1) $+ kb } | if $1 >= 0 { return $1 bytes } | else { return none }

; Script messaging
; ---------------------------
alias a if $left($1,2) == -c { echo $right($1,1) $iif(%tst == on,-at,-a) %pre $2- } | else { echo $iif(%tst == on,-at,-a) %pre $1- }
alias _a return $iif(%tst == on,echo -at,echo -a) %pre
alias e if $left($1,2) == -c { echo $right($1,1) $iif(%tst == on,-t) $2 %pre $3- } | else { echo $iif(%tst == on,-t) $1 %pre $2- }
alias _e return $iif(%tst == on,echo -t,echo) %pre
alias s echo $iif(%tst == on,-st,-s) %pre $1-
alias _s return $iif(%tst == on,echo -st,echo -s) %pre
alias _c var %tmp = 0 | :loop | inc %tmp | if ($comchan($1,%tmp)) { e $comchan($1,%tmp) $2- | goto loop }
alias _c2 if ($query($1)) { e $1 $2- } | else { a $2- }

alias des describe $1-
alias op mode # +ooo $$1 $2-
alias dop mode # -ooo $$1 $2-
alias join join #$$1 $2-
alias j join #$$1 $2-
alias p part # $1-
alias n names #$$1
alias w whois $$1
alias k kick # $$1
alias b ban # $$1 2
alias q query $$1
alias h halt
alias hdef haltdef
alias send dcc send $1 $2
alias chat dcc chat $1
alias ping ctcp $$1 ping

; Script localization 
; ---------------------------
alias cfgfil return $cfgdir $+ borgirc.ini
alias rcfg run $cfgfil
alias cfgdir return $sysdir $+ ini\
alias dlldir return $sysdir $+ dll\
alias sysdir return $shortfn($mircdir) $+ system\
alias txtdir return $sysdir $+ txt\
alias fxdir return $sysdir $+ Sound\
alias gfxdir return $sysdir $+ gfx\
alias devlog run $verdir $+ whatsnew.txt
alias mrcdir return $sysdir $+ mrc\
alias verdir return $sysdir $+ ver\
alias upddir return $sysdir $+ bupdate\
alias indir return $sysdir $+ incoming\

; BorgIRC dialog extensions
; -----------------------------------------

alias dl.open if ($dex($1)) { dialog -m $1 $1 } | else { dialog -a $1 }
alias dex if ($dialog($1).x == $null) { return $true } | else { return $false }
alias td set -u %tmp 1 | :loop | if $gettok($3-,%tmp,44) { did $1 $2 $gettok($3-,%tmp,44) | inc %tmp | goto loop }

; syntax: /cd dialog id matchtext
alias cd var %tmp = 0 | while (%tmp < $did($1,$2).lines) { inc %tmp | if ($3- == $did($1,$2,%tmp).text) { did -c $1 $2 %tmp | goto end } } |  :end
alias md set -u %tmp $3 | :loop | if %tmp != $4 { did $1 $2 %tmp | inc %tmp | goto loop }
alias md2 var %tmp = 0 | :loop | inc %tmp | if $gettok($4-,%tmp,44) { did $1 $2 $3 $gettok($4-,%tmp,44) | goto loop }
alias md3 { 
  var %tmp = $3 
  while (%tmp <= $4) { did $1 $2 %tmp | inc %tmp }
}

; BorgIRC dialog progress bar
; --------------------------------------------

dialog pbar {
  size -1 -1 135 30
  option dbu
  title "BorgIRC 2"
  text "Initializing...",1,3 6 120 7
  text "0%",2, 116 6 19 7,right
  text "0 0 100",3,3 15 129 10
  button "Anuleren",99,145 175 50 20,cancel hide
}
alias pupd  {
  did -o pbar 3 1 $round($1,1)
  did -o pbar 2 1 $1 $+ % 
  if ($2-) { did -o pbar 1 1 $2- }
}

alias ptitle dialog -t pbar $1-
alias pbar dl.open pbar | if ($1-) { ptitle $1- }
alias pkill mdxr | dialog -x pbar

on *:DIALOG:*pbar:init:*:{
  mdx MarkDialog $dname

  mdx SetControlMDX 3 progressbar smooth > [ $gdll ]
  if ($dname == spbar) {
    mdx SetDialog $dname style dlgmodal
    mdx SetDialog $dname bgcolor $rgb(237,242,252)
    mdx SetColor $dname 1,2,3,99 textbg $rgb(237,242,252)
    mdx SetColor $dname 1,2,3,99 background $rgb(237,242,252)
    did -a $dname 3 barcolor $rgb(0,0,125) | did -a $dname 3 bgcolor $rgb(255,255,255)
  }
  else {
    did -a $dname 3 barcolor $rgb(0,0,125) | did -a $dname 3 bgcolor $rgb(face)
  }
}

; Misc.
; --------
alias borgver return $readini($cfgfil,general,Version)
alias lanver return $readini($cfgfil,general,LanSys)
alias _url return 12 $+ $readini $cfgfil general url $+ 
alias rdate return $readini $cfgfil general date
alias logo return 12(BorgIRC12)
alias quitmsg return BorgIRC $borgver - by: STING - $_url $+  
alias getcfg return $readini($cfgfil,config,$1)
alias getccfg return $readini($cfgfil,$1,$2)

alias ms if ($1-) { echo -s $1- } | else { echo -s - }
alias ea if ($1-) { echo -a $1- } | else { echo -s /ea - error: no parameters given }
alias fm1 return $chr(91) $+  $+ $1- $+  $+ $chr(93)
alias fm2 return $chr(91) $+ $1- $+ $chr(93)
alias fm3 return  $+ $1- $+ 

alias ~ return $chr(91) $+  $+ $1- $+  $+ $chr(93)
alias ^ return $chr(91) $+ $1- $+ $chr(93)

alias cm {
  if ($query(0) > 0) { var %q = $query(0) | var %no = 0
    while (%q >= 0) { if ($query(%q) != $active) { closemsg $query(%q) } | dec %q }
  }
}

alias bico return $shortfn($mircdir $+ system\gfx\borgirc.ico)

alias cfgdir_f return $cfgdir $+ borgfx.ini

alias cfgw1 writeini $cfgfil Config $1-
alias cfgw2 writeini $cfgfil $1-

alias cfgon cfgw1 $1 $true
alias cfgoff cfgw1 $1 $false

alias x return $crlf $+
alias us .unload -rs $shortfn($scriptdir) $+ $1- $+ .mrc
alias mus var %tmp = 1 | while ($gettok($1-,%tmp,44)) { us $gettok($1-,%tmp,44) | inc %tmp }
alias sups window -pdk +f @BorgiRC $int($calc(($window(-1).w - 304) / 2)) $int($calc(($window(-1).h - 148) / 2)) 304 148 | drawpic @BorgIRC 0.1 0.1 $gfxdir $+ startup.png | .timerclose 1 3 window -c @BorgIRC

alias chkfx { var %no = 0
  while (%no < $numtok($fx_ext,35)) {
    inc %no | var %tmp = $gettok($fx_ext,%no,35)
    if ($flgrab(%tmp) == $null) { fx_w3 %tmp flgrab $true }
    if ($flserv(%tmp) == $null) { fx_w3 %tmp flserv $true }
    if ($flap(%tmp) == $null) { fx_w3 %tmp flap $true }
    if ($flvp(%tmp) == $null) { fx_w3 %tmp flvp $true } | if ($flvph(%tmp) == $null) { fx_w3 %tmp flvph $true }
    if ($flvps(%tmp) == $null) { fx_w3 %tmp flvps $true } | if ($flctcp(%tmp) == $null) { fx_w3 %tmp flctcp $true }
    if ($flm(%tmp) == $null) { fx_w3 %tmp flm $true }
  }
}

alias chkint { if (%chkint) { return }
  var %tmp0 = $cfgdir $+ int.inf | var %tmp1 = $cfgdir $+ borgirc.ini | var %tmp2 = $cfgdir $+ borgfx.ini
  if ($exists(%tmp0) == $false) { fx alert | s Script integrity check 4FAILED | s %not Authentication file is missing - you are running a non-standard BorgIRC copy, proceed at your own risk. | var %a = $true }
  if ($exists(%tmp1) == $false) { fx alert | s Script integrity check 4FAILED | s %not Main configuration file is missing - BorgIRC may not function properly. Re-installation is advised. | var %a = $true }
  if ($exists(%tmp2) == $false) { fx alert | s Script integrity check 4FAILED | s %not Sound system configuration file is missing - The sound system may not function properly. Re-installation is advised. | var %a = $true }
  if (%a) { return }
  var %tmp = 0 
  while (%tmp < $lines(%tmp0)) { 
    inc %tmp 
    set -u %tmp2 $read(%tmp0,%tmp) 
    set -u %tmp3 $shortfn($scriptdir) $+ $gettok(%tmp2,1,32) 
    set -u %tmp4 $gettok(%tmp2,2,32) 
    if ($crc(%tmp3) != %tmp4) { fx alert | s Script integrity check 4FAILED | s %not This copy of BorgIRC has been modified. If errors occur re-install BorgIRC. The author does not support modified versions. To prevent this message from being displayed type /nocheck. | linesep | return } 
  }
  s Script integrity check 3OK
}

alias nocheck fx button | %chkint = $true | a %not You have disabled the script integrity check.


alias tbar {
  if (%tbar != on) { return }
  if ($1 == -l) { set %lag $2 } 
  elseif ($1) { set %tb.txt $1- } 
  if ($1 == -c) { unset %tb.txt } 
  if (($server) && (%l.d == on)) { var %tmp = [lag: %lag $+ s] } 
  else { unset %tmp } 
  titlebar - BorgIRC $borgver 1998-2003 STING %tmp %tb.txt
}



; Interface aliases for: mdx.dll, fsmem.dll (Dragonzap), mUnzip.dll (Kamek), kTools.dll ([K]Freak)
; ------------------------------------------------------------------------------------------------------------------------------------------------
alias mdxr var %tmp = $mdx(Remove)
alias mdx return $dll($udll,$1,$2-)
alias gdll return $dlldir $+ ctl_gen.mdx
alias udll return $dlldir $+ mdx.dll
alias bdll return $dlldir $+ bars.mdx
alias vdll return $dlldir $+ views.mdx
alias tokdid if ($isid == $true) return $gettok($did($1,$2),$3,32) | did -o $1-2 1 $puttok($did($1,$2),$4-,$3,32)
alias fdll return $dlldir $+ fsmem.dll
alias unzdll return $dlldir $+ mUnzip.dll
alias kdll return $dlldir $+ kTools.dll

on *:DIALOG:*pbar:init:0:{
  var %tmp = MARK: $mdx(MarkDialog,$dname)
  var %tmp = $mdx(SetControlMDX,3 progressbar smooth > [ $gdll ] )
  did -a $dname 3 barcolor $rgb(0,0,125) | did -a $dname 3 bgcolor $rgb(face)
}

; nLINKn DLL by Necroman - Core aliases
; ----------------------------------------------------------------

alias nLINKn return $dlldir $+ nLINKn.dll

alias addicon {
  ; $1 -  path  $2 - dir $3 - icon $4 - Destination: ie. $dll($nLINKn,specdir,0)
  ;  0 = Desktop, 2 = Start menu\Programs, 6 = Favorites
  if ($4 == $null) { a -c2 /addicon: Insufficient parameters | h }
  var %tmp = $dll($nLINKn,set,path $mircexe)
  var %tmp = $dll($nLINKn,set,dir $mircdir)
  var %tmp = $dll($nLINKn,set,icon 0 c:\borgir~2\system\gfx\borgirc.ico)
  var %tmp = $dll($nLINKn,save,$shortfn($4-) $+ \BorgIRC.lnk)
}
; /addicon $shortfn($mircexe) $shortfn($mircdir) $shortfn($mircdir $+ system\gfx\borgico.ico) $dll($nLINKn,specdir,2)

; BorgIRC popup extensions
; ------------------------------------------

; English gender data
alias gn1 if (%g.pop) { return $iif(%gender == male,his,her) } | else { return his }
alias gn2 if (%g.pop) { return $iif(%gender == male,him,her) } | else { return him }
alias gn3 if (%g.pop) { return $iif(%gender == male,he,she) } | else { return he }

alias on1 if (%g.pop) { return $iif(%o.gender == male,his,her) } | else { return her }
alias on2 if (%g.pop) { return $iif(%o.gender == male,him,her) } | else { return her }
alias on3 if (%g.pop) { return $iif(%gender == male,he,she) } | else { return she }

; Dutch gender data
alias ^gn1 if (%g.pop) { return $iif(%gender == male,zijn,haar) } | else { return zijn }
alias ^gn2 if (%g.pop) { return $iif(%gender == male,hem,haar) } | else { return hem }
alias ^gn3 if (%g.pop) { return $iif(%gender == male,hij,zij) } | else { return hij }

alias ^on1 if (%g.pop) { return $iif(%o.gender == male,zijn,haar) } | else { return haar }
alias ^on2 if (%g.pop) { return $iif(%o.gender == male,hem,haar) } | else { return haar }
alias ^on3 if (%g.pop) { return $iif(%gender == male,hij,zij) } | else { return zij }


; BorgUpdate interface
; ----------------------------------

alias update { 
  unset %miss
  if ($server == $null) { fx comply | a %err BorgUpdate can only be used when you are connected to a server. | h }
  var %tmp = $$input(BorgUpdate is an option to easily keep your BorgIRC up-to-date. $x $x $+ If you press Ok BorgUpdate will search for updates and install them if applicable. $x $x $+ WARNING: You can lose own/custom modifications of BorgIRC scripts files as a consequence of updates. $x $x $+ BorgUpdate will only work with open network connections. Proxies/routers are not supported. Important updates can be downloaded from the BorgIRC site.,128,BorgUpdate)

  if (%tmp) {
    ; Pre-load self diagnostics
    ; --------------------------------------
    unset %miss | var %fil1 = $mrcdir $+ bupdate.mrc

    if ($isfile($unzdll) == $false) { var %miss = %fil0 }
    if ($isfile(%fil1) == $false) { var %miss = %fil1 }
    if ($isdir($indir) == $false) { .mkdir $indir }
    if (%miss) { beep | .echo -q $input(BorgUpdate cannot load due to a missing critical file. Please re-install BorgIRC. File: %miss,516,BorgUpdate) | h }

    if ($tim(autocheck)) { .timerautocheck off }
    if ($tim(bcheck)) { .timerbcheck off }
    cfgw2 general lastup $ctime

    ; DDE routines
    if ($os == ME) { .timercheckupdatefile 0 1 borgupd_check }
    else {
      .ddeserver off
      if ($isdde(borgirc_uk)) { beep | .echo -q $input(BorgUpdate cannot be started because another instance of BorgIRC is running. Please close it first.,oh,BorgUpdate) | h }
      .ddeserver on borgirc_uk
    }
    run -ns $shortfn($mircexe) -i $+ $upddir $+ mirc.ini
  }
}

alias update.host {
  goto $1
  :1 | cfgw2 general BUpdate.host 1 | return
  :2 | cfgw2 general BUpdate.host 2 | return
  :3 |
  var %tmp = $iif($gettok($getccfg(general,bupdate.host),2,32),$ifmatch,www.geocities.com)
  var %custom = $$input(Please input the BorgUpdate server name. $x $x $+ IMPORTANT! Only do this, if so advised by STING by e-mail.,129,Configure BorgUpdate server,%tmp)
  cfgw2 general BUpdate.host 3 %custom
}

alias borgupd_check {
  var %tmp = $indir $+ bupdate.tmp
  if ($exists(%tmp)) { 
    beep
    var %yesno = $input(An update has been installed. BorgIRC needs to be restarted.,yw.,BorgUpdate)
    .remove %tmp
    if (%yesno) { exit }
  }
}
